// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

import junit.framework.*;

public class TestKey extends TestCase{

     static Class[] testClasses = new Class[] {
    
   	de.uka.ilkd.key.collection.TestSetAsListOfString.class,
   	de.uka.ilkd.key.collection.TestSLListOfString.class,
   	de.uka.ilkd.key.collection.TestMapAsListFromIntegerToString.class,
   	de.uka.ilkd.key.logic.TestTermFactory.class,
   	de.uka.ilkd.key.logic.TestTerm.class,
   	de.uka.ilkd.key.logic.TestToArrayVisitor.class,
   	de.uka.ilkd.key.logic.TestNamespace.class,
   	de.uka.ilkd.key.logic.TestConstraint.class,
   	de.uka.ilkd.key.logic.TestSemisequent.class,
   	de.uka.ilkd.key.logic.TestPosInOcc.class,
   	de.uka.ilkd.key.rule.TestApplyTaclet.class,
   	de.uka.ilkd.key.logic.TestClashFreeSubst.class,
   	de.uka.ilkd.key.proof.TestTacletIndex.class,
   	de.uka.ilkd.key.proof.TestProofTree.class,
   	de.uka.ilkd.key.proof.incclosure.TestMerger.class,
  	de.uka.ilkd.key.rule.TestMatchTaclet.class,
	de.uka.ilkd.key.rule.TestSchemaModalOperators.class,
  	de.uka.ilkd.key.rule.TestTacletBuild.class,
  	de.uka.ilkd.key.java.TestRecoder2KeY.class,
 	de.uka.ilkd.key.java.TestKeYRecoderMapping.class,
  	de.uka.ilkd.key.rule.metaconstruct.TestProgramMetaConstructs.class,
   	de.uka.ilkd.key.proof.TestGoal.class,
   	de.uka.ilkd.key.parser.TestDeclParser.class,
   	de.uka.ilkd.key.parser.TestTermParser.class,
  	de.uka.ilkd.key.parser.TestTacletParser.class,
  	de.uka.ilkd.key.logic.TestSyntacticalReplaceVisitor.class,
  	de.uka.ilkd.key.logic.TestSimultaneousUpdateSimplifier.class,
  	de.uka.ilkd.key.logic.TestContextStatementBlock.class,
  	de.uka.ilkd.key.rule.TestCollisionResolving.class,
	de.uka.ilkd.key.java.visitor.TestJavaIterator.class,
	de.uka.ilkd.key.java.visitor.TestDeclarationProgramVariableCollector.class,
	de.uka.ilkd.key.util.pp.TestLayouter.class,
 	de.uka.ilkd.key.rule.inst.TestGenericSortInstantiations.class,
 	de.uka.ilkd.key.logic.TestTermOrdering.class,
 	de.uka.ilkd.key.collection.TestLeftistHeapOfInteger.class,
	de.uka.ilkd.key.proof.TestTermTacletAppIndex.class,
 	de.uka.ilkd.key.rule.soundness.TestProofObligationCreation.class,
	de.uka.ilkd.key.proof.mgt.TestAbstractMethodLemmaFactory.class,
	de.uka.ilkd.key.parser.TestTermParserOCL.class,
	de.uka.ilkd.key.parser.TestTacletParserOCL.class,
	de.uka.ilkd.key.rule.TestOCLTaclets.class
    };


    public static junit.framework.Test suite() {
	de.uka.ilkd.key.util.Debug.ENABLE_DEBUG = false; 

	TestSuite suite=new TestSuite();

	for ( int i = 0; i < testClasses.length; i++ ) {
	    suite.addTest(new TestSuite(testClasses[i]));
	}

	return suite;
    }

    public TestKey(String name) {
	super(name);
    }

}

