// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.asmkey.logic;

import de.uka.ilkd.key.logic.Term;
import de.uka.ilkd.key.logic.op.ArrayOfQuantifiableVariable;
import de.uka.ilkd.key.logic.ListOfName;
import de.uka.ilkd.key.logic.SLListOfName;
import de.uka.ilkd.asmkey.logic.dfinfo.DFInfo;

/** Special implementation of
 * rules, with support for static analysis of rules
 * in particular, simplification of con and joinable
 * predicates.
 *
 * @author Stanislas Nanchen
 */

class AsmRule extends AsmTerm implements UpdateDFInfoContainer {
   
    private DFInfo may_update_functions = null;

    public DFInfo getUpdateDFInfo() {
	return may_update_functions;
    }

    public void setUpdateDFInfo(DFInfo info) {
	may_update_functions = info;
    }

    AsmRule(AsmOperator op, Term[] terms, ArrayOfQuantifiableVariable vars) {
	super(op, terms, vars);
    }
}

