// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.asmkey.logic;


import de.uka.ilkd.key.logic.Name;
import de.uka.ilkd.key.logic.sort.Sort;
import de.uka.ilkd.key.logic.Term;


/** Dynamic (non-rigid) function with time argument for timed
 * logic.
 * 
 *
 * @author Stanislas Nanchen */

public final class TimedDynamicFunction extends DynamicFunction {


    /** creates a new instance with the given name, sort and sorts of
     * arguements. See {@link DynamicFunction#DynamicFunction(Name, Sort,
     * Sort[])}. */
    public TimedDynamicFunction(Name name, Sort sort, Sort[] argSorts) {
        super(name, sort, argSorts);
    }

}
