// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.asmkey.parser.ast;


/** Visitor for schema types.
 *
 * @see AstSchemaType
 * @author Hubert Schmid
 */

public interface AstSchemaTypeVisitor {

    /** Primitive schema type. */
    void visitPrimitive(PrimitiveSchemaType type);

    /** Schema type composed of a sort. If variable is true, the
     * schema variable matches only logical variables. */
    void visitComposed(Identifier sort, boolean variable);

    /** Schema type for depending variables (skolem functions). */
    void visitDepending(Identifier sort);

}
