// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

package de.uka.ilkd.key.casetool;

// attention: do not import java.util.Collection
// The tudresden-package contains a class with the same name
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;
import java.io.*;

import tudresden.ocl.check.types.*;
import tudresden.ocl.check.OclTypeException;

import de.uka.ilkd.key.ocl.tudresden.*;
import de.uka.ilkd.key.java.*;
import de.uka.ilkd.key.java.recoderext.*;

import recoder.service.*;
import recoder.abstraction.Package;
import recoder.list.*;
import recoder.convenience.*;
import recoder.io.*;
import recoder.util.*;
import recoder.java.*;


public class OCLModelFacade extends OCLParserModelFacade {

    private HashMapOfClassifier classifiers;

    public OCLModelFacade(HashMapOfClassifier classifiers) {
	this.classifiers = classifiers;
	
    }

    public Any getClassifier(String name) {
	return classifiers.getClassifier(name);
    }

    public String toString() {
	return classifiers.toString();
    }

}
