// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.key.casetool;

import  de.uka.ilkd.key.gui.ModelSourceSettings;
import  de.uka.ilkd.key.gui.ProofSettings;
import de.uka.ilkd.key.util.KeYResourceManager;
import de.uka.ilkd.key.ocl.ocldltranslator.detailedocl.*;
import de.uka.ilkd.key.ocl.*;
import de.uka.ilkd.key.casetool.HashMapOfClassifier;
import tudresden.ocl.check.types.ModelFacade;
import java.io.*;
import java.net.*;
import java.util.*;


public class StandaloneJavaModelManager implements ModelManager {

    public final static StandaloneJavaModelManager INSTANCE 
	= new StandaloneJavaModelManager();

    private static Map models = new WeakHashMap();

    private StandaloneJavaModelManager() {}

    public ModelFacade getModelFacade
	(String location, String modelId) {

	ModelFacade res = (ModelFacade) models.get(modelId);
	if (res!=null) return res;	
	UMLOCLModel model;
	OCLMod[] mods=new OCLMod[]{NullMod.SINGLETON, 
				   ArrayMod.SINGLETON, 
				   ExcThrownMod.SINGLETON};
	model = new DetUMLOCLModel(location);
	for (int i=0; i<mods.length; i++) {
	    ((DetUMLOCLModel)model).addListener(mods[i]);
	}	    
	HashMapOfClassifier classifiers = model.getUMLOCLClassifiers();
	res = new OCLModelFacade(classifiers);		
	if (modelId!=null) models.put(modelId, res);
	return res;
    }	
}
