// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.key.casetool.together;

import de.uka.ilkd.key.java.abstraction.Type;
import de.uka.ilkd.key.logic.op.ProgramMethod;

import com.togethersoft.openapi.sci.*;
import com.togethersoft.openapi.sci.enum.*;
import com.togethersoft.openapi.rwi.*;
import com.togethersoft.openapi.ide.*;
import com.togethersoft.openapi.ide.window.*;
import com.togethersoft.openapi.ide.diagram.*;

class ModelUtilImpl {

    private ModelUtilImpl() {}

   static void hiliteMethod(Type t, ProgramMethod pm) {
      SciModel sciModel = SciModelAccess.getModel(); 
      RwiModel rwiModel = RwiModelAccess.getModel(); 


      SciClass cl = sciModel.findClass(SciLanguage.JAVA,t.getFullName());      
      SciMember op = SciUtil.findMemberBySignature(cl, pm.togetherSignature(), 
                                                   true);

//      SciOperationEnumeration openum = cl.operations();
//      while (openum.hasMoreElements())
//         System.out.println(openum.nextSciOperation().getSignature());
//      System.out.println("op="+op);


      RwiElement rwiOp = rwiModel.findMember(op);

      IdeDiagramManager diaMan = IdeAccess.getDiagramManager();
      RwiDiagram rwiDiagram2 = rwiModel.findDiagramFor(rwiOp);
      IdeDiagram dia = diaMan.openDiagram(rwiDiagram2, true);
      diaMan.setActiveDiagram(dia);
      IdeDiagramElement idx = dia.findElement(rwiOp);
//      System.out.println(idx);
      dia.unselectAll();
      dia.select(idx);
   }

}


