// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//
//
//

/** @author Kristofer Johannisson */

package de.uka.ilkd.key.casetool.together;

import java.util.Iterator;
import java.util.Arrays;
import java.util.HashMap;
import java.util.TreeSet;
import java.util.Collection;

import java.io.*;
import java.util.*;

import de.uka.ilkd.key.casetool.*;
import de.uka.ilkd.key.casetool.together.UMLOCLTogetherModel;
import tudresden.ocl.check.types.Type;
import org.apache.log4j.Logger;
import de.uka.ilkd.key.ocl.gf.*;

/** control object interfacing KeY with GF */
public class TogetherGFInterface extends GFinterface
{

    public TogetherGFInterface()
    {
    	// set up logging
    	logger = Logger.getLogger("key.ocl.gf");
    	// Logger test = Logger.getRootLogger();
    	// test.error("GFinterface testing root logger...");
    
        // get the UML model

        projectRoot = UMLOCLTogetherModel.getTogetherProjectDir();
        model = new UMLOCLTogetherModel();

        // set up the filter (list) for features inherited from the java class "Object"
        String[] names = {"clone", "equals", "finalize", "getClass", "hashCode",
            "notify", "notifyAll", "toString", "wait"};
        fromObject = Arrays.asList(names);

        // set up list of OCL types
        String[] types = {"OclType", "OclAny", "OclState", "OclExpression", "Real", "Integer", "String",
            "Boolean", "Enumeration"};
        inOCL = Arrays.asList(types);

        unknownAdded = new TreeSet();
    }

}
