// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

/* Generated by Together */

// All implementing classes should have a name of 
// "OpMenu" + ...  

package de.uka.ilkd.key.casetool.together.scripts.menuextension;

import de.uka.ilkd.key.casetool.together.TogetherReprModelMethod;
import de.uka.ilkd.key.casetool.ReprModelMethod;

import com.togethersoft.openapi.ide.window.IdeDialogType;
import com.togethersoft.openapi.ide.window.IdeWindowManager;
import com.togethersoft.openapi.ide.IdeContext;

import com.togethersoft.openapi.rwi.RwiElement;
import com.togethersoft.openapi.rwi.RwiDiagram;
import com.togethersoft.openapi.rwi.RwiModel;
import com.togethersoft.openapi.rwi.RwiReference;
import com.togethersoft.openapi.rwi.RwiMemberReference;
import com.togethersoft.openapi.rwi.RwiMember;



public abstract class  OpMenu {
    public abstract String getMenuEntry();

    public abstract String getSubMenuName();

    public void run(IdeWindowManager winMan, IdeContext context, RwiModel rwiModel, RwiDiagram rwiDiagram){
        RwiElement[] selectedRwiElements = context.getRwiElements();
		RwiElement selectedRwiElement = selectedRwiElements[0];
		RwiReference selectedRef = rwiDiagram.findReference(selectedRwiElement);
		// if a operation is selected it is always a member (so the cast
		// shouldn't be dangerous
		RwiMember selectedMember = ((RwiMemberReference) selectedRef).getMember();
	    TogetherReprModelMethod aReprModelMethod = new TogetherReprModelMethod(selectedMember, rwiModel, rwiDiagram);

        String result = runCore(aReprModelMethod);

		if (!result.equals("")){
	    	winMan.showMessageDialog("Result", IdeDialogType.INFORMATION, result);
		}
    }

    protected abstract String runCore(ReprModelMethod aReprModelMethod);
}
