// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.key.gui;

/** InteractiveProofListener defines the interface 
 * for an object that listens to the state of an interactive proof
 */
public interface InteractiveProofListener {

    /** 
     * invoked if automatic execution has started
     */
    void autoModeStarted(ProofEvent e);
    
    /**
     * invoked if automatic execution has stopped
     */
    void autoModeStopped(ProofEvent e);
    
    /** invoked when a rule has been applied */
    void ruleApplied(ProofEvent e);
} 
