// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//


package de.uka.ilkd.key.java;

/**
 *  Expression container.
 * taken from COMPOST and changed to achieve an immutable structure
 */

public interface ExpressionContainer extends NonTerminalProgramElement {

    /**
 *      Get the number of expressions in this container.
 *      @return the number of expressions.
     */
    int getExpressionCount();

    /*
      Return the expression at the specified index in this node's
      "virtual" expression array.
      @param index an index for an expression.
      @return the expression with the given index.
      @exception ArrayIndexOutOfBoundsException if <tt>index</tt> is out
      of bounds.
    */
    Expression getExpressionAt(int index);
}
