// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

// This file is taken from the RECODER library, which is protected by the LGPL,
// and modified.

package de.uka.ilkd.key.java.recoderext;

import recoder.*;
import recoder.list.*;
import recoder.java.*;
import recoder.java.statement.*;
import recoder.java.declaration.*;
import recoder.java.reference.*;
import recoder.convenience.*;
import recoder.abstraction.*;
import recoder.util.*;

import java.util.Enumeration;

/**
   Statement block.
   @author AL
   @author <TT>AutoDoc</TT>
 */

public class ContextStatementBlock
    extends StatementBlock implements KeYRecoderExtension{

    private ExecutionContext ec;
        
    /**
     Statement block.
     */
    public ContextStatementBlock() {
    }

    /**
     Statement block.
     */
    public ContextStatementBlock(TypeSVWrapper tr, ExpressionSVWrapper runtime) {
	this(tr != null ? new ExecutionContext(tr, runtime) : null);
    }

    /**
     Statement block.
     */
    public ContextStatementBlock(ExecutionContext ec) {
	this.ec = ec;
    }

    /**
     Statement block.
     @param block a statement mutable list.
     */
    public ContextStatementBlock(TypeSVWrapper tr, ExpressionSVWrapper runtime, 
				 StatementMutableList block) {
	super(block);
	if (tr != null) {
	    this.ec = new ExecutionContext(tr, runtime);
	} else {
	    this.ec = null;
	}
    }

    /**
     Statement block.
     @param proto a statement block.
     */

    protected ContextStatementBlock(ContextStatementBlock proto) {
        super(proto);
	this.ec = proto.getExecutionContext();
    }


    public TypeSVWrapper getClassContext() {
	return (TypeSVWrapper)ec.getTypeReference();
    }

    public ExpressionSVWrapper getRuntimeInstance() {
	return (ExpressionSVWrapper)ec.getRuntimeInstance();
    }

    public ExecutionContext getExecutionContext() {
	return ec;
    }

}
