// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//


package de.uka.ilkd.key.java.recoderext;

import recoder.*;
import recoder.java.*;
import recoder.java.statement.*;
import recoder.java.expression.*;
import recoder.list.*;
import recoder.java.reference.*;

import de.uka.ilkd.key.logic.op.SchemaVariable;

public class ExpressionSVWrapper extends Literal implements Expression, 
    LoopInitializer, KeYRecoderExtension, SVWrapper, ReferencePrefix{
   
    protected SchemaVariable sv;
    protected ReferenceSuffix suff;

    
    protected StatementContainer statementParent=null;

    protected ExpressionSVWrapper(ExpressionSVWrapper proto) {
        super(proto);
	expressionParent=null;
    }

    public ExpressionSVWrapper() {
	expressionParent=null;
    }

    public ExpressionSVWrapper(SchemaVariable sv) {
	this.sv=sv;
	expressionParent=null;
    }

    /**
     Make parent role valid.
     */
    public void makeParentRoleValid() {
    }  
 
    /**
     Get AST parent.
     @return the non terminal program element.
     */
    public NonTerminalProgramElement getASTParent() {        
	return expressionParent;
    }
   

    /**
     * sets the schema variable of sort statement
     * @param s the String
     */
    public void setSV(SchemaVariable sv) {
	this.sv=sv;
    }

    /**
     * returns a String name of this meta construct.
     */
    public SchemaVariable getSV() {
	return sv;
    }


   /**
     Get expression container.
     @return the expression container.
     */
    public ExpressionContainer getExpressionContainer() {
        return expressionParent;
    } 

    /**
     Set expression container.
     @param c an expression container.
     */
    public void setExpressionContainer(ExpressionContainer c) {
        expressionParent = c;
    }

    //don't think we need it
    public void accept(SourceVisitor v) {
    }
    
    public Object deepClone() {
	return new StatementSVWrapper(sv);
    }

    /**
     Get statement container.
     @return the statement container.
     */
    public StatementContainer getStatementContainer() {
	return statementParent;
    }

    /**
     Set statement container.
     @param c a statement container.
     */
    public void setStatementContainer(StatementContainer c) {
	statementParent=c;
    }


    public ReferenceSuffix getReferenceSuffix() {
	return suff;
    }

    /**
     Set reference suffix.
     @param path a reference suffix.
     */
    public void setReferenceSuffix(ReferenceSuffix path) {
	suff=path;
    }
}
