// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//


package de.uka.ilkd.key.java.recoderext;

import recoder.*;
import recoder.java.*;
import recoder.java.statement.*;
import recoder.java.expression.*;
import recoder.list.*;
import recoder.java.reference.*;

import de.uka.ilkd.key.logic.op.SchemaVariable;

public class SpecialReferenceWrapper extends ThisReference 
    implements Expression, KeYRecoderExtension, ReferencePrefix {
   
    protected TypeReference typeRef;
    protected ReferencePrefix myprefix;

    
    protected StatementContainer statementParent=null;

    public SpecialReferenceWrapper() {
	expressionParent=null;
    }


    public SpecialReferenceWrapper(TypeReference typeRef, 
				   ReferencePrefix myprefix) {
	this.typeRef = typeRef;
	this.myprefix  = myprefix;
	expressionParent=null;
    }

    protected SpecialReferenceWrapper(SpecialReferenceWrapper proto) {
        super(proto);
	expressionParent=null;
    }


    /**
     Make parent role valid.
     */
    public void makeParentRoleValid() {
    }  
 
    /**
     Get AST parent.
     @return the non terminal program element.
     */
    public NonTerminalProgramElement getASTParent() {        
	return expressionParent;
    }
   

   /**
     Get expression container.
     @return the expression container.
     */
    public ExpressionContainer getExpressionContainer() {
        return expressionParent;
    } 

    /**
     Set expression container.
     @param c an expression container.
     */
    public void setExpressionContainer(ExpressionContainer c) {
        expressionParent = c;
    }

    //don't think we need it
    public void accept(SourceVisitor v) {
    }
    
    public Object deepClone() {
	return new SpecialReferenceWrapper(typeRef, myprefix);
    }

    /**
     Get statement container.
     @return the statement container.
     */
    public StatementContainer getStatementContainer() {
	return statementParent;
    }

    /**
     Set statement container.
     @param c a statement container.
     */
    public void setStatementContainer(StatementContainer c) {
	statementParent=c;
    }

    public TypeReference getTypeReference() {
	return typeRef;
    }

    /**
     Set reference suffix.
     @param path a reference suffix.
     */
    public void setTypeReference(TypeReference ref) {
	this.typeRef=typeRef;
    }

    public ReferencePrefix getReferencePrefix() {
	return myprefix;
    }

    /**
     Set reference suffix.
     @param path a reference suffix.
     */
    public void setReferencePrefix(ReferencePrefix myprefix) {
	this.myprefix=myprefix;
    }
}
