// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
package de.uka.ilkd.key.logic;


/**
 * This class describes the deletion strategy used by the simultan update
 * simplifier. The deletion strategy removes updates (or parts of a simultaneous
 * one) if e.g. there exists an update like {x:=x} or the location in the update
 * is not refered to during the rest of the term behind the update.
 */
public interface DeletionStrategy {

    DeletionStrategy copy();
    Term delete(Term t);

}
