// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.key.logic.op;

import de.uka.ilkd.key.logic.Name;
import de.uka.ilkd.key.logic.Term;

/**
 * Shadow Array access operator used in transactions
 */
public class ShadowArrayOp extends ArrayOp implements ShadowedOperator {

    /**
     * creates an ShadowArrayOp
     */
    ShadowArrayOp(Name name){
        super(name);
    }
    
    /** @return arity of the Operator as int */
    public int arity(){
        return 3;
    }

    /**
     * @return true if the operator is a shadowed 
     */
    public boolean isShadowed() {
	return true;
    }

    public Term getTransactionNumber(Term t) {
	return t.sub(2);
    }

}

