// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.key.logic.op;

import de.uka.ilkd.key.logic.sort.Sort;
import de.uka.ilkd.key.logic.sort.ProgramSVSort;
//import de.uka.ilkd.key.gui.LogicPrinter;
import java.io.IOException;
import de.uka.ilkd.key.logic.ProgramConstruct;
import de.uka.ilkd.key.logic.Name;

class VariableSV extends SortedSchemaVariable {

    /** creates a new SchemaVariable. That is used as placeholder for
     * bound(quantified) variables.
     * @param name the Name of the SchemaVariable
     * @param sort the Sort of the SchemaVariable and the matched type     
     * @param listSV a boolean which is true iff the schemavariable is allowed
     * to match a list of quantified variables
     */    
    VariableSV(Name name,
		       Sort sort,
		       boolean listSV) {
	super(name, QuantifiableVariable.class, sort, listSV); 	
    }
    
    /** returns true iff this SchemaVariable is used to match
     * bound (quantifiable) variables 
     * @return true iff this SchemaVariable is used to match
     * bound (quantifiable) variables 
     */
    public boolean isVariableSV() {
	return true;
    }
    
    public boolean isRigid () {
	return true;
    }
    
    /** toString */
    public String toString() {
	return toString("variable");
    }
}
