// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

/* Generated by Together */

package de.uka.ilkd.key.logic.op;

import de.uka.ilkd.key.logic.sort.Sort;
import de.uka.ilkd.key.logic.Name;
import de.uka.ilkd.key.logic.Term;
import de.uka.ilkd.key.logic.WaryClashFreeSubst;

public class WarySubstOp extends SubstOp {

    private final boolean allQuantifier;
    
    WarySubstOp(Name name, boolean p_allQuantifier) {
	super(name);
	allQuantifier = p_allQuantifier;
    }

    public boolean validTopLevel(Term term){
	return
	    super.validTopLevel ( term ) &&
	    term.sub(1).sort () == Sort.FORMULA;
    }

    /**
     * When applying this substitution below a modality, should an
     * existential or an universal quantifier be created
     */
    public boolean getAllQuantifier () {
	return allQuantifier;
    }

    /**
     * Apply this substitution operator to <code>term</code>, which
     * has this operator as top-level operator
     */
    public Term apply ( Term term ) {
	QuantifiableVariable v=term.varsBoundHere(1).getQuantifiableVariable(0);
	WaryClashFreeSubst cfSubst = new WaryClashFreeSubst(v, term.sub(0),
							    allQuantifier);
	Term res = cfSubst.apply(term.sub(1));
	return res;	
    }    
}
