// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//
//
//

/** @author Kristofer Johannisson */

package de.uka.ilkd.key.ocl.gf;

//import de.uka.ilkd.key.ocl.tudresden.TJClassifier;
import de.uka.ilkd.key.casetool.ReprModelClass;

/** provides a interface for letting the GF editor send class invariants back to KeY */
public class CallbackClassInv
{
	boolean useTJC;
    	Object tjc; 
	ReprModelClass rmc;
	
	
	/** send invariant to Together using methods in ReprModelClass */
	public CallbackClassInv(ReprModelClass rmc)
	{
		this.rmc = rmc;
		useTJC = false;
	}
	
	public void sendInvariant(String invAbs, String invOCL, String invEng)
	{
// 		System.out.println("CallbackClassInv received these invariants:");
// 		System.out.println("    Abs: " + invAbs);
// 		System.out.println("    OCL: " + invOCL);
// 		System.out.println("    Eng: " + invEng);
		
		// pass inv on to KeY

	    rmc.setMyInv(invOCL);
	    rmc.setMyInvGFAbs(invAbs);
		
	}
}
