// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//
package de.uka.ilkd.key.ocl.ocldltranslator;

import de.uka.ilkd.key.logic.*;
import de.uka.ilkd.key.logic.op.Quantifier;


/**
 * Some constants to be used for the translation of OCL expression into
 * DL formulas for the KeY-System
 */


public interface TranslationConstants  {
    
    String PLUS = "+";
    String BINARY_MINUS = "~d";
    String UNARY_MINUS = "~m";
    String MULTIPLICATION = "mul";
    String DIVISION = "div";
     
    String LESS_THAN = "lt";
    String LESS_OR_EQUAL_THAN = "leq";
    String GREATER_THAN = "gt";
    String GREATER_OR_EQUAL_THAN = "geq";


    String COUNT = "count";
    String CONTAINS = "includes";
    String SIZE = "size";
    String SUM = "sum";

    String SET_INSERT = "including";
    String SET_REMOVE = "excluding";
    String SET_EMPTYSET = "emptySet";
    String SET_UNION = "union";
    String SET_INTERSECTION = "intersection";
    
    String BAG_INSERT = "insert";
    String BAG_REMOVE = "remove";
    String BAG_EMPTYBAG = "emptyBag";
    String BAG_UNION = "union";
    String BAG_INTERSECTION = "intersection";

    String SEQUENCE_AT = "at";
    String SEQUENCE_INSERT = "append";
    String SEQUENCE_REMOVE = "remove";
    String SEQUENCE_EMPTYSEQUENCE = "emptySequence";
    String SEQUENCE_UNION = "union";
    String SEQUENCE_FIRST = "first";
    String SEQUENCE_LAST = "last";
    String SEQUENCE_APPEND = "append";
    String SEQUENCE_PREPEND = "prepend";
    String SEQUENCE_SUBSEQUENCE = "subsequence";
   
    String INSTANCE_OF = "instanceof";
    String IS_TYPE_OF = "isTypeOf";
    String AS_TYPE = "asType";
    String CREATED = "created";
    String ALL_INSTANCES = "allInstancesOf"; 

    String INT_MOD = "mod";
    String INT_DIV = "div";
    String INT_MAX = "max";
    String INT_MIN = "min";
    String INT_ABS = "abs";

    String REAL_MAX = "max";
    String REAL_MIN = "min";
    String REAL_ABS = "abs";
    String REAL_FLOOR = "floor";
    String REAL_ROUND = "round";

    
    String STRING_CONCAT = "concat";
    String STRING_APPEND = "append";
    String STRING_TO_UPPER = "toUpper";
    String STRING_TO_LOWER = "toLower";
    String STRING_SUBSTRING = "substring";
    String STRING_EMPTYSTRING = "emptyString";

    String BOOLEAN_AND = "jAnd";
    String BOOLEAN_OR = "jOr";
    String BOOLEAN_NOT = "jNot";
    String BOOLEAN_IMPLIES = "implies";
    String BOOLEAN_EQUALS_TO_BOOLEAN = "equals";
    String BOOLEAN_TRUE = "TRUE";
    String BOOLEAN_FALSE = "FALSE";

}








