// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.key.ocl.ocldltranslator.detailedocl;

import tudresden.ocl.check.types.*;

import java.util.*;

import de.uka.ilkd.key.casetool.*;

public class DetJavaOCLTypeMap extends JavaOCLTypeMap {
    
    private Vector listeners=new Vector();

    public DetJavaOCLTypeMap(HashMapOfClassifier cls) {
	super(cls);
    }

    public void addListener(OCLMod listener) {
	listeners.add(listener);
    }

    public void addListeners(OCLMod[] l) {
	for (int i=0; i<l.length; i++) {
	    listeners.add(l[i]);
	}
    }

    
    public Type getTypeFor(recoder.abstraction.Type type, 
			   HashMapOfClassifier classes){
	Iterator it=listeners.iterator();
 	while (it.hasNext()) {
	    OCLMod currentMod=(OCLMod)it.next();
	    Type t = currentMod.getTypeFor(type, classes, this);
	    if (t!=null) return t;
	}
	return super.getTypeFor(type, classes);
    }
    
}
