// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

package de.uka.ilkd.key.ocl.ocldltranslator.detailedocl;

import de.uka.ilkd.key.casetool.*;
import java.util.Iterator;
import java.util.Vector;

import recoder.abstraction.ClassType; 
import recoder.list.CompilationUnitList;


public class DetUMLOCLModel extends UMLOCLJavaModel {

    private Vector listeners=new Vector();
    private static UMLOCLClassifier nullClass
	= new UMLOCLClassifier("Null", "Null");
    
    public DetUMLOCLModel(String location) {
	super(location);
    }

    protected UMLOCLClassifier createUMLOCLClassifier(ClassType ct) {
	UMLOCLClassifier cls = new UMLOCLClassifier(ct.getName(),
						    ct.getFullName());
	Iterator it = listeners.iterator();
	while (it.hasNext()) {
	    ((OCLMod)it.next()).addFeatureToUMLOCLClassifier(cls);
	}
	return cls;
    }

    protected void findAllClasses(CompilationUnitList cuList) {
	super.findAllClasses(cuList);
	Iterator it = listeners.iterator();
	while (it.hasNext()) {
	    ((OCLMod)it.next()).modifyAllTypes(classifiers);
	}
    }

    protected JavaOCLTypeMap getJavaOCLTypeMap
	(HashMapOfClassifier classifier) {
	
	DetJavaOCLTypeMap res = new DetJavaOCLTypeMap(classifiers);
	Iterator it = listeners.iterator();
	while (it.hasNext()) {
	    res.addListener((OCLMod)it.next());
	}
	return res;
    }

    public void addListener(OCLMod listener) {
	listeners.add(listener);
    }

    
}
