// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//
package de.uka.ilkd.key.ocl.ocldltranslator.detailedocl;

import de.uka.ilkd.key.ocl.ocldltranslator.*;
import java.util.*;

public class DetailedConstraintPrep {

    String constraint;
    String result;

    private Vector listeners=new Vector();    

    public DetailedConstraintPrep(String constraint) {
	this.constraint=constraint;
    }

    public void addListener(OCLMod listener) {
	listeners.add(listener);
    }


    public void addListeners(OCLMod[] l) {
	for (int i=0; i<l.length; i++) {
	    listeners.add(l[i]);
	}
    }


    public void transform() {      
	boolean changed=false;
 	Iterator it=listeners.iterator();
	result=constraint;
 	while (it.hasNext()) {
	    OCLMod currentMod=(OCLMod)it.next();
 	    if (currentMod.transformOCL(result)) {
		changed = true;
		result=currentMod.getOCLConstraint();
	    }
 	}
    }

    public String result() {
	return result;
    }


    public static void main(String args[]) {
	DetailedConstraintPrep prep = new DetailedConstraintPrep(" null=dasd(dsf (fdf d) sdfsd) and asds.sdas(adsd (asd asd asd) sda (asd) asdsa) =null) and dasd=null asd) null=sdad ");
	prep.transform();
	System.out.println(prep.result());
    }

}
