// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.key.proof;

import de.uka.ilkd.key.rule.*;

/**
 * Filter that selects taclets that belong to at least one
 * heuristic, i.e. taclets that can be applied automatically.
 */
public class AnyHeuristicTacletFilter extends TacletFilter {

    private AnyHeuristicTacletFilter () {
    }

    /**
     * @return true iff <code>taclet</code> should be included in the
     * result
     */
    public boolean filter ( Taclet taclet ) {
	return taclet.getHeuristics () != SLListOfHeuristic.EMPTY_LIST;
    }

    public static TacletFilter INSTANCE = new AnyHeuristicTacletFilter ();
}
