// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.key.proof.mgt;

import java.util.*;
import de.uka.ilkd.key.proof.ProofList;

/** represents a set of contracts (@link{Contract}}) with attached proofs.*/
public class ContractSet {
    
    private Set contracts = new HashSet();

    public void add(Contract ct) {
        contracts.add(ct);
    }

    public Iterator iterator() {
	return contracts.iterator();
    }

    public void removeProofList(ProofList pl) {
	for (Iterator it=iterator(); 
	     it.hasNext(); 
	     ((Contract)it.next()).removeProofList(pl));
    }

}
