// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

/** this class is used to realize a rule variable. That is variable
 * that stands for a Taclet and is used only in rule descriptions
 */
package de.uka.ilkd.key.rule;

import de.uka.ilkd.key.logic.Named;
import de.uka.ilkd.key.logic.Name;
public class Rulevariable implements Named {
    /** name of the rulevariable */
    private Name name;
    
    /** creates a new Rulevariable
     * @param name Name object represents name of the Rulevariable 
     */
    public Rulevariable(Name name) {
	this.name=name;
    } 
    
    /** toString */
    public String toString() {
	return name.toString();
    }

    public Name name(){
	return name;
    }
}
