// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//
//
//

package de.uka.ilkd.key.rule.metaconstruct;
import de.uka.ilkd.key.java.ProgramElement;
import de.uka.ilkd.key.java.Expression;
import de.uka.ilkd.key.java.Services;
import de.uka.ilkd.key.java.reference.*;
import de.uka.ilkd.key.java.expression.literal.BooleanLiteral;
import de.uka.ilkd.key.java.expression.operator.Instanceof;
import de.uka.ilkd.key.rule.inst.SVInstantiations;
import de.uka.ilkd.key.logic.op.ProgramVariable;


/**
 * currently, this class is not used. When we have seen that the old
 * instanceof handling is no more needed we can remove it. /AR 7/9/03
 *
 * This meta constructs evaluates the instanceof expression.
 * This means: an expression 'x instanceof T' is replaced with true if x is an
 * instance of the type T or one of the subtypes of T.  
 */
public class InstanceOfEval extends ProgramMetaConstruct {
    
     /** creates an instance-of ProgramMetaConstruct 
     * @param expr the instance of expression contained by 
     * the meta construct 
     */
    public InstanceOfEval(Expression expr) {
	super("static-evaluate", expr); 
	
    }

    /** performs the program transformation needed for symbolic
     * program transformation 
     * @return the transformated program
     */
    public ProgramElement symbolicExecution(ProgramElement pe,
					    Services services,
					    SVInstantiations insts) {
	Instanceof instOf = (Instanceof) pe;
	TypeReference typeRef = instOf.getTypeReference();
	ProgramVariable variableRef = null;
	if (instOf.getChildAt(0) instanceof VariableReference) {
	    variableRef = ((VariableReference) instOf.getChildAt(0)).
		getProgramVariable();
	} else if (instOf.getChildAt(0) instanceof ProgramVariable){
	    variableRef = (ProgramVariable) instOf.getChildAt(0);
	}
	if (services.getJavaInfo().isSubtype(variableRef.getKeYJavaType(), 
			       typeRef.getKeYJavaType())) {
	    return new BooleanLiteral(true);
	} else if (!(services.getJavaInfo().isSubtype(typeRef.getKeYJavaType(), 
					variableRef.getKeYJavaType()))){
	    return new BooleanLiteral(false);
	} else {
	    return instOf;
	}
    }
}
