// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.key.rule.metaconstruct;


import de.uka.ilkd.key.java.Expression;
import de.uka.ilkd.key.java.reference.TypeRef;
import de.uka.ilkd.key.java.Services;
import de.uka.ilkd.key.logic.sort.Sort;
import de.uka.ilkd.key.logic.Name;
import de.uka.ilkd.key.logic.Term;
import de.uka.ilkd.key.rule.inst.SVInstantiations;
import de.uka.ilkd.key.logic.op.ExpressionOperator;
import de.uka.ilkd.key.logic.op.SchemaVariable;
import de.uka.ilkd.key.logic.op.Op;
import de.uka.ilkd.key.logic.TermFactory;

public class IsCertainReference extends ExpressionOperator {

    protected String[] types;

    public IsCertainReference(Name name, String[] types, 
			      Sort sort, Expression expr) {
	super(name, sort, expr);
	this.types = types;
    }

    public Term resolveExpression
	(SVInstantiations svInst, Services services) {

	Expression exp = expression();
	if (exp instanceof SchemaVariable){	   
	    TypeRef type = (TypeRef)svInst.
		getInstantiation((SchemaVariable)exp);		
	    String t = type.getKeYJavaType().getFullName();
	    for (int i=0; i<types.length; i++) {
		if (t.equals(types[i]))
		    return  TermFactory.DEFAULT.createJunctorTerm(Op.TRUE);
	    }
	    return   TermFactory.DEFAULT.createJunctorTerm(Op.FALSE);
	}
	throw new IllegalArgumentException("Argument has to be a "+
					    "schema variable!!!");
    }


}
