// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.key.strategy;

import de.uka.ilkd.key.logic.Name;
import de.uka.ilkd.key.proof.Proof;


/**
 *
 */
public class SimpleJavaCardDLWithoutLoopsAndMethodBodiesStrategy 
    extends SimpleJavaCardDLWithoutLoopsStrategy {
    
    public static final Name JAVADL_WOLOOPS_ANDMB_NAME =
        new Name ( "Simple JavaCardDL without expanding loops "
		   +"and method bodies" );

    public SimpleJavaCardDLWithoutLoopsAndMethodBodiesStrategy ( Proof p_proof ) {
        super ( p_proof );

        completeF = add ( completeF,
                          ifHeuristics( new String [] { "method_expand" },
                                        inftyConst() ) );
    }
    
    public Name name () {
        return JAVADL_WOLOOPS_ANDMB_NAME;
    }

    public static class Factory extends StrategyFactory {
        public Strategy create ( Proof p_proof ) {
            return new SimpleJavaCardDLWithoutLoopsAndMethodBodiesStrategy 
		( p_proof );
        }
        
        public Name name () {
            return JAVADL_WOLOOPS_ANDMB_NAME;
        }
    }
}
