// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2004 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

package de.uka.ilkd.key.strategy.feature;

import de.uka.ilkd.key.logic.PosInOccurrence;
import de.uka.ilkd.key.logic.Term;
import de.uka.ilkd.key.strategy.RuleAppCost;


/**
 * Binary feature that returns zero iff the focus of a rule contains a
 * quantifier
 */
public class ContainsQuantifierFeature extends AbstractBetaFeature {

    public final static Feature INSTANCE = new ContainsQuantifierFeature ();

    protected RuleAppCost doComputation (PosInOccurrence pos, Term findTerm) {
        return containsQuantifier ( findTerm )
                     ? BinaryFeature.ZERO_COST
                     : BinaryFeature.TOP_COST;
    }

}
